Imports System.Data
Imports System.Data.SqlClient
Public Class AcessoDB

    Public Sub New()
    End Sub

    Private cn As String

    Public Sub New(ByVal strConexao As String)
        'permite que usemos uma string de conexo diferente da padro
        cn = strConexao
    End Sub
    Protected Function getConexao() As SqlConnection
        Dim retCon As SqlConnection
        retCon = New SqlConnection(cn)
        'abre a conexao
        retCon.Open()
        'retorna a conexao
        getConexao = retCon
    End Function

    Protected Sub closeConexao(ByVal con As SqlConnection)
        'fecha a conexao
        con.Close()
        con = Nothing
    End Sub
    Public Overloads Function retornaDataReader(ByVal strSP As String, ByVal ParamArray cmdParametros() _
                              As SqlParameter) As SqlDataReader
        'obtem a string de conexao
        Dim cn As SqlConnection = getConexao()
        Dim dr As SqlDataReader

        'cria um objeto command a partir da stored procedure
        Dim cmd As New SqlCommand(strSP, cn)

        cmd.CommandType = CommandType.StoredProcedure
        Dim par As SqlParameter

        'percorre a coleo de paremetros
        For Each par In cmdParametros
            par = cmd.Parameters.Add(par)
            par.Direction = ParameterDirection.Input
        Next

        'executa o comando e retorna o datareader
        dr = cmd.ExecuteReader(CommandBehavior.CloseConnection)
        cmd.Dispose()

        Return dr
    End Function
    Public Overloads Function retornaDataReader(ByVal strSP As String) As SqlDataReader
        'obtem a conexao
        Dim cn As SqlConnection = getConexao()
        Dim dr As SqlDataReader

        'cria o objeto command a partir da stored procedure
        Dim cmd As New SqlCommand(strSP, cn)
        cmd.CommandType = CommandType.Text
        'exeucta o comando
        dr = cmd.ExecuteReader(CommandBehavior.CloseConnection)
        cmd.Dispose()

        'retorna o datareader
        Return dr
    End Function

    Public Function retornaDataSet(ByVal strSP As String, ByVal dt As String, _
                    ByVal ParamArray cmdParametros() As SqlParameter) As DataSet

        'obtem a conexao
        Dim cn As SqlConnection = getConexao()
        Dim ds As New DataSet

        'define um dataAdapter
        Dim da As New SqlDataAdapter(strSP, cn)
        da.SelectCommand.CommandType = CommandType.StoredProcedure

        Dim par As SqlParameter

        'percorre a coleo de paremetros
        For Each par In cmdParametros
            da.SelectCommand.Parameters.Add(par)
            par.Direction = ParameterDirection.Input
        Next

        'preenche o datatabel
        da.Fill(ds, dt)

        'fecha conexao
        closeConexao(cn)
        da.Dispose()

        'retorna o dataset
        Return ds

    End Function

End Class
